Bug 93461 - Skylake VLC/Skype video doesn't work
Summary: Skylake VLC/Skype video doesn't work
Status: NEW
Alias: None
Product: xorg
Classification: Unclassified
Component: Driver/intel (show other bugs)
Version: git
Hardware: Other All
: medium normal
Assignee: Chris Wilson
QA Contact: Intel GFX Bugs mailing list
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2015-12-20 21:18 UTC by Nikolay
Modified: 2016-11-08 16:42 UTC (History)
8 users (show)

See Also:
i915 platform:
i915 features:


Attachments
xorg config file to switch to modesetting driver with glamor (137 bytes, text/plain)
2016-03-26 10:48 UTC, Philipp Edelmann
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Nikolay 2015-12-20 21:18:01 UTC
I've got a lenovo laptop with i5-6200U.

  When I make a call using skype incoming video seem to be not scaled properly - i.e. it's just a small rectangle in large window. If I enable outgoing video the whole window starts blinking with blue and video seemingly stops moving.

  No additional errors logged in dmesg.
  I'm using latest oibaf with Ubuntu 14.04.

  There is another description of similar problem: http://askubuntu.com/questions/710960/video-display-problems-ubuntu-on-asus-ux305-skype-and-vlc-and-other-programs (by a different person).

  I would be happy to provide any additional information required.

Thanks!
Comment 1 Nikolay 2016-01-09 06:11:25 UTC
I would like to mention that this is really annoying issue: skype video calls become unusable.

Also, there is no such problem on Ivybridge, so it seems to be related to certain newer hardware.

I'd be really happy to help testing fixes or by providing more information but unfortunately I do not know even where to start to dig into the code to fi it myself.
Comment 2 Nikolay 2016-01-09 07:20:12 UTC
One more thing that I've noticed: video from skyle (and from VLC) seems to be in 'always on top' mode - i.e. no other window can cover it. And it looks like that when I enable camera there are to 'always on top' windows in the same region (incoming and outgoing video) - and those constantly 'fight' with lots of flickering.
Comment 3 tomasz 2016-01-14 19:31:06 UTC
Hi guys,
I have Dell XPS 13 (the one here: https://wiki.archlinux.org/index.php/Dell_XPS_13_%282016%29). I confirm some problems mentioned: no scaling in VLC or mplayer, "always on the top" issue. I didn't use skype with video so I cannot confirm.

I'll also add an occasional flickering of the whole screen and in one case: I completely scrambled screen that I could fix only by restarting the whole machine.
Comment 4 tomasz 2016-01-14 19:32:36 UTC
I'll also add that I'm running the last 4.4 kernel that I compiled myself for Debian.
Comment 5 Nikolay 2016-01-14 19:44:42 UTC
I did some more digging into this and it looks like that this hardware doesn't support XVideo somehow (this was briefly mentioned in some ticket, but I'm not sure I will be find it) - and apparently it needs some sort of emulation that clearly doesn't work properly.

Work around is adding this to xorg.conf:

Section "Extensions"
Option "XVideo" "Disable"
EndSection

This disables XVideo altogether. This made Skype a bit more usable - no flickering anymore, but I cannot see image from my own camera. Another problem is that XVideo was designed to make things faster and disabling it might make video jerky and eat more power.

As for VLC (and probably mplaer) - there is a way to select different video output. I think VLC defaults to XVideo because it's like the oldest and not-that-bad way to effectively render video.

Even though there are apparently semi-working workarounds it seems like broken XVideo extension is still a bug of Intel driver for these CPUs.
Comment 6 Philipp Edelmann 2016-03-26 10:48:03 UTC
Created attachment 122574 [details]
xorg config file to switch to modesetting driver with glamor
Comment 7 Philipp Edelmann 2016-03-26 10:48:59 UTC
I found a similar bug report in Redhat. The solution there was to switch from the the intel driver (with apparently no support for acceleration and Xv on Skylake) to the modesetting driver using glamor (using OpenGL for acceleration and Xv). I tried it on Debian Sid system and everything (including Xv in media players and Skype) works fine. I attach the config snippet that I put into /etc/X11/xorg.conf.d to make this work.
Comment 8 Nikolay 2016-03-26 21:30:58 UTC
Hi.

Just to point out that glamour is known to be slower than sna so even though this might be a work around, it might not work as permanent fix.
Comment 9 Andrea Bocci 2016-03-29 22:46:56 UTC
Confirmed on Dell XPS 15 9550 (Intel Skylake i7-6700HQ) with Ubuntu 15.10, Linux kernels 4.4.x, 4.5.0, 4.6-rc1 and the latest Intel Graphics drivers from 01.org .
Comment 10 Philipp Edelmann 2016-04-05 16:13:59 UTC
I just tried the recent commit 2c4890001 from the xf86-video-intel git repository and it fixes the problem for me using the intel driver. I am testing on the XPS 13 with Skylake.
Comment 11 Philipp Edelmann 2016-04-05 16:33:18 UTC
By fixed I mean that the xv video buffers are resized correctly. I did a short performance comparison of xv and opengl output with a 4K video full screen on a 4K screen using mpv. Using opengl it takes about 10% CPU on one core. With xv it needs 150% (more than one core). Still it is great that this works now.
Comment 12 Faraz Hussain 2016-04-10 03:11:23 UTC
Nikolay, thanks for your comment dated "2016-01-14 19:44:42 UTC" -- that's a lifesaver. Simultaneous incoming and outgoing video on skype works perfectly now.

I have Ubuntu 15.10 (4.2.0-35-generic) on Dell Latitude E5470 that has Intel i7-6820HQ, Sky Lake (rev 07).  If/when I update my kernel to 4.5 or 4.6, will this disabling xv workaround not be needed anymore?
Comment 13 Faraz Hussain 2016-04-10 04:35:05 UTC
Nikolay, many thanks for your comment dated "2016-01-14 19:44:42 UTC" -- its a lifesaver! Simultaneous incoming and outgoing video on skype works perfectly now. I have Ubuntu 15.10 (4.2.0-35-generic) on Dell Latitude E5470 that has Intel i7-6820HQ, Sky Lake (rev 07).  

I wonder if this disabling xv workaround will still be needed if/when I update my kernel to 4.5 or 4.6 ...
Comment 14 Andor Kiss 2016-06-09 16:55:54 UTC
This also affects/effects me.

Ubuntu 16.04.1 LTS AMD64 with i7500 Sky Lake HD520 chipset

Have to manually disable Xv extensions in xorg.conf to be able to use SKYPE.  SKYPE with PIP flashes blue and is unusable.

The Intel Video Driver is at fault
Comment 15 Nishanth Aravamudan 2016-07-06 00:33:02 UTC
@Phillip, re c10, did you mean you had only taken that commit? Or did you use a tree with that commit as HEAD?
Comment 16 Philipp Edelmann 2016-07-06 07:38:59 UTC
(In reply to Nishanth Aravamudan from comment #15)
> @Phillip, re c10, did you mean you had only taken that commit? Or did you
> use a tree with that commit as HEAD?

I applied just that commit on what was the current version in Debian sid back then. I guess it must have been version 2.99.917+git20160325.

Btw. I tried the current git master of xf86-video-intel yesterday and xv performance feels a lot better, basically the same as with the glamor driver. I haven't done extensive tests yet.
Comment 17 Nishanth Aravamudan 2016-07-06 16:25:53 UTC
(In reply to Philipp Edelmann from comment #16)
> (In reply to Nishanth Aravamudan from comment #15)
> > @Phillip, re c10, did you mean you had only taken that commit? Or did you
> > use a tree with that commit as HEAD?
> 
> I applied just that commit on what was the current version in Debian sid
> back then. I guess it must have been version 2.99.917+git20160325.
> 
> Btw. I tried the current git master of xf86-video-intel yesterday and xv
> performance feels a lot better, basically the same as with the glamor
> driver. I haven't done extensive tests yet.

Thanks for the clarification. I tried to do that in a PPA for the Ubuntu bug and I saw some improvement (less blue) but still flickering and the window would not properly maximize. Using the version from 16.10 directly (as documented in the Ubuntu bug) worked fine.
Comment 18 Dan Dart 2016-07-21 19:25:19 UTC
I note also that videos do not scale using "mplayer -vo x11" but do with "-vo gl" or "-vo xv".
Using kernel 4.6 and xserver-xorg-video-intel 2:2.99.917+git1607211930.6988b8~gd~x from oibaf on this skylake.

Games et al run fine.

Is the accepted solution to disable xvideo and/or use glamore?

Is it possible that this would be integrated into the latest version?

Cheers


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct.